#include <PID_v1.h>
#include <QTRSensors.h>
//sensor da 0V para cor escura, e 5V para cor branca

float Kp=0;
float Ki=0;
float Kd=0;// estes 3 valores vao ter que ser ajustados testando com o carrinho ate maxima optimizacao
float error=0;
float P=0;
float I=0;
float D=0;
float value_PID=0;
float error_last=0;
float I_last=0;
float Vel_Inicial=150;//velocidade inicial dos motores (pode ser aumentada ou diminuida para obter melhores resultados)
float Vel_Motor_Right=150;
float Vel_Motor_Left=150;
#define NUM_SENSORS 5
#define NUM_SAMPLES_PER_SENSOR 4
QTRSensorsAnalog qtra((unsigned char[]) {0, 1, 2, 3, 4},  NUM_SENSORS, NUM_SAMPLES_PER_SENSOR);
unsigned int sensorValues[NUM_SENSORS];
void setup() {
  pinMode(3,OUTPUT);//PWM from left motor
  pinMode(5,OUTPUT);//PWM from right motor
  pinMode(2,OUTPUT); //pin 1  motor left (-)
  pinMode(4,OUTPUT); //pin 2  motor left (+)
  pinMode(7,OUTPUT); //pin 1  motor right (-)
  pinMode(8,OUTPUT); //pin 2  motor right (+)
  Serial.begin(9600); //Enable Serial Communications
  int i;
  for (i = 0; i < 250; i++)  // make the calibration take about 5 seconds
  {
    qtra.calibrate();
    delay(20);
  }

}

void loop() {
  read_sensor_values();
  motor_drive();
}

void read_sensor_values()
{
  unsigned int sensors[5];
  int position = qtra.readLine(sensors);
  int error = position - 2000;
  if (error<-500)
  {
    Vel_Motor_Left=0;
  }
  if (error > 500)
  {
    Vel_Motor_Right=0;
  }
}
void motor_drive()
{
  analogWrite(3, Vel_Motor_left);
  analogWrite(5, Vel_Motor_Right);
  digitalWrite(2,LOW);
  digitalWrite(4,HIGH);
  digitalWrite(7,LOW);
  digitalWrite(8,HIGH);
}

